# INSIEMI
set Canali    := 1..2;
set Direzioni := {'salita','discesa'};

# DATI
param l_strett {Canali};            # Lunghezza delle strettoie [km]
param v_corr   {Canali};            # Velocit della corrente [km/h]
param v_a := 10;                    # Velocit delle chiatte [km/h]
param q := 1500;                    # Capacit delle chiatte [ton]

# VARIABILI
var flusso {Canali,Direzioni} >=0;  # Flusso [n. chiatte/h]

# OBIETTIVO
# Massimizzazione del flusso di merce [ton/h]
maximize z:
  sum {c in Canali} flusso[c,'salita'] * q;

# VINCOLI
subject to Conservazione_flusso:
  sum {c in Canali} flusso[c,'salita'] = sum {c in Canali} flusso[c,'discesa'];

# Massimo flusso attraverso la strettoia
subject to Strettoie {c in Canali}:
  flusso[c,'salita'] * l_strett[c]/(v_a-v_corr[c]) + flusso[c,'discesa'] * l_strett[c]/(v_a+v_corr[c]) <= 1;

##########################
data;

param:   l_strett   v_corr :=
  1        0.5        2
  2        0.75       1;

end;
